
(define (node-list-reduce nl combine init)
  (if (node-list-empty? nl)
      init
      (node-list-reduce (node-list-rest nl)
			combine
			(combine init (node-list-first nl)))))

(define (node-list-contains? nl snl)
  (node-list-reduce nl
		    (lambda (result i)
		      (or result
			  (node-list=? snl i)))
		    #f))

(define (node-list-remove-duplicates nl)
  (node-list-reduce nl 
		    (lambda (result snl)
		      (if (node-list-contains? result snl)
			  result
			  (node-list result snl)))
		    (empty-node-list)))

(define (node-list-filter proc nl)
  (node-list-reduce nl
		    (lambda (result snl)
		      (if (proc snl)
			  (node-list snl result)
			  result))
		    (empty-node-list)))

(define (map proc l)
  (let loop ((result '())
	     (l l))
    (if (null? l)
	result
	(loop (cons (proc (car l)) result) (cdr l)))))

(define (node-list->list nl)
  (let loop ((result '())
	     (nl nl))
    (if (node-list-empty? nl)
	result
	(loop (cons (node-list-first nl) result) (node-list-rest nl)))))
